#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct notas
{
    char *nomeAluno;
    float nota;
}Notas;

void recebeDados (Notas *n, int numAlunos)
{
    int i;
    for (i = 0 ; i < numAlunos; i++)
    {
        do
        {
            printf ("\nDigite nome do Aluno %d: ", i + 1);
            fflush (stdin);
            gets (n[i].nomeAluno);
            if (strlen (n[i].nomeAluno) == 0)
            {
                printf ("nome invalido!!\n");
            }
        }
        while (strlen (n[i].nomeAluno) == 0);
        do
        {
            printf ("\nDigite a nota do aluno %d: ", i + 1);
            scanf ("%f", &n[i].nota);
            if (n[i].nota > 10 || n[i].nota < 0)
            {
                printf ("\nNota invalida!!\n");
            }
        }
        while (n[i].nota > 10 || n[i].nota < 0);
    }
}

float calculaMedia (Notas *n, int numAlunos)
{
    int i;
    float soma = 0;
    for (i = 0; i < numAlunos; i++)
    {
        soma += n[i].nota;
    }
    return ((float)(soma / numAlunos));
}

void imprimeAlunosFinal (Notas *n, int numAlunos)
{
    int i, cont = 0;
    printf ("Alunos na final:\n");
    for (i = 0; i < numAlunos; i++)
    {
        if (n[i].nota >= 3 && n[i].nota < 7)
        {
            printf ("Nome: ");
            puts (n[i].nomeAluno);
            printf ("Nota: %.2f\n\n", n[i].nota);
            cont++;
        }
    }
    if (cont == 0)
    {
        printf ("Nenhum\n\n");
    }
}


int main()
{
    Notas *n;
    int numAlunos, i;
    do
    {
        printf ("Digite o numero de alunos: ");
        scanf ("%d", &numAlunos);
        if (numAlunos <= 0)
        {
            printf ("\nNumero de alunos invalido!!\n\n");
        }
    }
    while (numAlunos <= 0);
    n = (Notas *) malloc (numAlunos * sizeof (Notas));

    for (i = 0; i < numAlunos; i++)
    {
        n[i].nomeAluno = (char *) malloc (101 * sizeof (char));
    }

    recebeDados (n, numAlunos);
    printf ("\nMedia dos alunos: %.2f\n\n", calculaMedia (n, numAlunos));
    imprimeAlunosFinal (n, numAlunos);

    for (i = 0; i < numAlunos; i++)
    {
        free (n[i].nomeAluno);
    }
    free (n);

    return 0;
}


